<?php

/*

OOP for performing geotude location conversions.

http://www.aaronland.info/php/Geotude/
Copyright (c) 2007 Aaron Straup Cope.

This is free software, you may use it and distribute it under the
terms of the Perl Artistic License.

$Id: Geotude.php,v 1.4 2007/08/16 05:13:29 asc Exp $

*/

class Geotude {

		function Geotude($args=array()){
			
			$this->_point = null;
			$this->_geotude = null;
				
			if ((isset($args['latitude'])) && (isset($args['longitude']))){
				$this->_point = array($args['latitude'], $args['longitude']);
			}
			
			if (isset($args['geotude'])){
				$this->_geotude = explode(".", $args['geotude'], 2);
			}
		}

		function get_geotude(){

			if (! is_array($this->_geotude)){
				$this->_geotude = $this->point2geotude($this->_point[0], $this->_point[1]);
			}

			return $this->_geotude;
		}

		function get_point(){

			if (! is_array($this->_point)){
				$this->_point = $this->geotude2point(implode(".", $this->_geotude));
			}

			return $this->_point;
		}

		function geotude2point($geotude){

			$parts = explode(".", $geotude, 2);

			$major = $parts[0];
			$minor = explode(".", $parts[1]);

			$gt = $major - 10000;

			$lat_minor = "";
			$lon_minor = "";

			foreach ($minor as $precision){
				$lat_minor .= $precision[0];
				$lon_minor .= $precision[1];
			}

			$lat_major = floor(($gt - $gt % 500) / 500);
			$lon_major = floor($gt % 500);

			$lat = floatval(implode(".", array($lat_major, $lat_minor)));
			$lon = floatval(implode(".", array($lon_major, $lon_minor)));

			$lat = 90 - $lat;
			$lon = $lon - 180;

			return array($lat, $lon);
		}

		function point2geotude($lat, $lon){

			$lat_major = 90 - $lat;
			$lon_major = 180 + $lon;

			$parts_lat = explode(".", $lat_major, 2);
			$parts_lon = explode(".", $lon_major, 2);

			$lat_minor = $parts_lat[1];
			$lon_minor = $parts_lon[1];

			$gt_major = 500 * floor($lat_major) + floor($lon_major) + 10000;
			$gt_minor = array();

			$len = strlen($lat_minor);

			foreach (range(0, $len-1) as $i){				
				$str_minor = $lat_minor[$i];
				$str_minor .= $lon_minor[$i];
				$gt_minor[] = $str_minor;
			}

			return array($gt_major, implode(".", $gt_minor));
		}
}

?>